using System;
using System.IO;
using System.Xml;

namespace XMLBench {
 abstract public class XMLBench {
    public Random generator;
    
    public void Bench(string[] args) {
	if (args.Length<2) {
	    Console.WriteLine("Usage:\n\tme <iterations> [size]");
	}

	int iterations = Convert.ToInt32(args[0]);
	int size = Convert.ToInt32(args[1]);
	
	
	DateTime pre, post;
	TimeSpan ts = new TimeSpan(0);
	Disp d = new Disp();
	
	InitXML(size);
	
	ParseXML(size, iterations, 0);
	
	for (int i = 0; i < iterations; i++) {
	    
    	    pre = DateTime.Now;
	    ParseXML(size, iterations, i+1);
	    post = DateTime.Now;
	    d.disp_event((post - pre).TotalMilliseconds);
    
	    
	    ts += post - pre;

	}
	d.disp_post();
	
	ReleaseXML();

	Console.WriteLine("Mono Time: " + ts.TotalMilliseconds/iterations + " ms" + " (" + (300*d.disp_d/d.disp_m) + "%)");
    }
    virtual public void InitXML(int size) {
	generator = new Random();
    }
    virtual public void ReleaseXML() {}
    abstract public void ParseXML(int size, int iters, int iter);
 }
}
