#include <stdio.h>
#include <sys/time.h>
#include "include/util/reader.h"
#include "include/util/filereader.h"
#include "include/util/memoryreader.h"
#include "include/common/defines.h"
#include "include/common/types.h"
#include "include/common/source.h"
#include "include/common/exception.h"
#include "include/xpa/sax/saxparser.h"
#include "include/xpa/sax/saxparserfactory.h"
#include "include/xpa/sax/contenthandler.h"
#include "include/xpa/sax/dtdhandler.h"
#include "include/xpa/sax/entityresolver.h"
#include "include/xpa/sax/lexicalhandler.h"
#include "include/xpa/sax/locator2.h"

#include "tools.h"

using namespace std;
INTEL_XML_NAMESPACE_USE
INTEL_XML_UTIL_NAMESPACE_USE
INTEL_XML_PARSE_SAX_NAMESPACE_USE

class DocHandlers : public ContentHandler/*, public DTDHandler, public EntityResolver, public LexicalHandler*/ {
 public:
    void startElement(unsigned int namespaceTag, unsigned int elemNameCount, const XMLChar* elemName, unsigned int nAttribute, SAXAttribute** attrs);
    void endElement();
    void characters(unsigned int count, const XMLChar* string, bool more);
    void startNamespace(unsigned int newNamespaceTag, unsigned int prefixCount, const XMLChar* prefixString, unsigned int uriCount,const XMLChar* uriString);
    void endNamespace(unsigned int namespaceTag);
    void startDocument();
    void endDocument();
    void pi(unsigned int targetCount, const XMLChar* targetString, unsigned int dataCount, const XMLChar* dataString);
    void setDocumentLocator(Locator* locator);
    void skippedEntity(unsigned int count, const XMLChar* name);
};

void DocHandlers::startElement(unsigned int namespaceTag, unsigned int elemNameCount, const XMLChar* elemName, unsigned int nAttribute, SAXAttribute** attrs) {
    return;
}

void DocHandlers::endElement() {
    return;
}

void DocHandlers::characters(unsigned int count, const XMLChar* string, bool more) {
    return;
}
void DocHandlers::startNamespace(unsigned int newNamespaceTag, unsigned int prefixCount, const XMLChar* prefixString, unsigned int uriCount,const XMLChar* uriString) {
    return;
}
void DocHandlers::endNamespace(unsigned int namespaceTag) {
    return;
}
void DocHandlers::startDocument() {
}
void DocHandlers::endDocument() {
}
void DocHandlers::setDocumentLocator(Locator* locator) {
}
void DocHandlers::skippedEntity(unsigned int count, const XMLChar* name) {
}
void DocHandlers::pi(unsigned int targetCount, const XMLChar* targetString, unsigned int dataCount, const XMLChar* dataString) {
}

SAXParserFactory* saximpl;
SAXParser *parser;
DocHandlers *handler;

void initXML(struct TestData *td) {
    saximpl = SAXParserFactory::newInstance();
    parser = saximpl->createSAXParser();

    handler=new DocHandlers;
    parser->setContentHandler(handler);
    //parser->setDTDHandler(&sax2CoreDumper);
    //parser->setLexicalHandler(&sax2CoreDumper);
    //parser->setEntityResolver(&sax2CoreDumper);
}

void releaseXML(struct TestData *td) {
    delete handler;
    delete parser;
    delete saximpl;
}

void parseXML(struct TestData *td, unsigned long iter) {
    const char id[5]="ID1\0";

    MemoryReader *buffer;
    StreamSource *ss;

    buffer= MemoryReader::createMemoryReader(td->xml,td->xmllen);
    ss = new StreamSource(buffer, id);
//    buffer->setCopyBufToStream(false);
    parser->parse(ss);
    delete ss;
    delete buffer;
}


int main(int argc, char *argv[]) {
    return Test(argc,argv);
}
